package org.josast.CubesatSim;

import static org.junit.jupiter.api.Assertions.*;

import java.io.IOException;
import java.nio.file.DirectoryStream;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.Iterator;

import org.josast.ModuleSoundModem.KissException;
import org.josast.ModuleSoundModem.kiss;

import org.josast.kaitai.generated.Cubesatsim;
import org.junit.jupiter.api.AfterAll;
import org.junit.jupiter.api.AfterEach;
import org.junit.jupiter.api.BeforeAll;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;

import io.kaitai.struct.ByteBufferKaitaiStream;

class CubesatSimeFrameTest {
	
	int cpt=0;
	String generateRepository="src/test/resources";
	byte[] buff = null;
	Cubesatsim cube=null;

	@BeforeAll
	static void setUpBeforeClass() throws Exception {
	}

	@AfterAll
	static void tearDownAfterClass() throws Exception {
	}

	@BeforeEach
	void setUp() throws Exception {
	}

	@AfterEach
	void tearDown() throws Exception {
	}

	@Test
	void test() {
		
	//	FrameFactory ff = new FrameFactory();

        Path path = Paths.get(generateRepository);

        DirectoryStream<Path> stream;
		try {
			stream = Files.newDirectoryStream(path);

        try { 
          Iterator<Path> iterator = stream.iterator();
          while(iterator.hasNext()) {
            Path p = iterator.next();
            System.out.println(p); 
			byte [] kissbuff = Files.readAllBytes(p);
			kiss k = new kiss(kissbuff);
			buff =k.toRaw();
			 cube = new Cubesatsim(new ByteBufferKaitaiStream(buff));
			 System.out.println("Dest Asdress : "+ cube.ax25Header().destAddress().destAddressStr());
			 System.out.println("SRC Asdress : "+ cube.ax25Header().srcAddress().srcAddressStr());

//				System.out.println(tlmArea +" "+ typeFrame);				
//				Frame fm = ff.creerFrame(tlmArea, typeFrame);
//				fm.setUp(cube);
				
//				System.out.println(fm.toStringHeader());
//				System.out.println(fm.toString());
			
          }
        } catch (KissException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} finally { 
          stream.close(); 
        } 
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

}
